// Fill out your copyright notice in the Description page of Project Settings.

using System.IO;
using UnrealBuildTool;

public class libzmq : ModuleRules
{
    //public libzmq(TargetInfo Target)
    public libzmq(ReadOnlyTargetRules Target)
    {
        Type = ModuleType.External;

        //Definitions.Add("ZMQ_STATIC=1");

        string includePath = Path.Combine(ModuleDirectory, "include");
        PublicIncludePaths.AddRange(new string[] { includePath });

        if (Target.Platform == UnrealTargetPlatform.Win64)
        {
            // Add the import library
            PublicLibraryPaths.Add(Path.Combine(ModuleDirectory, "bin", "x64", "Release", "v140", "dynamic"));
            //PublicLibraryPaths.Add(Path.Combine(ModuleDirectory, "bin", "x64", "Release", "v140", "static"));
            PublicAdditionalLibraries.Add("libzmq.lib");

            // Delay-load the DLL, so we can load it from the right place first
            PublicDelayLoadDLLs.Add("libzmq.dll");
			
            //RuntimeDependencies.Add(new RuntimeDependency("libzmq.dll"));
        }
        else if (Target.Platform == UnrealTargetPlatform.Mac)
        {
            PublicDelayLoadDLLs.Add(Path.Combine(ModuleDirectory, "Mac", "Release", "libzmq.dylib"));
        }
    }
}
